diff --git a/ArmPlatformPkg/ArmVirtualizationPkg/Library/ResetSystemLib/AARCH64/ResetSystemPsci.S b/ArmPlatformPkg/ArmVirtualizationPkg/Library/ResetSystemLib/AARCH64/ResetSystemPsci.S
new file mode 100644
index 000000000000..988b0fdc41e4
--- /dev/null
+++ b/ArmPlatformPkg/ArmVirtualizationPkg/Library/ResetSystemLib/AARCH64/ResetSystemPsci.S
@@ -0,0 +1,40 @@
+/** @file
+  Support ResetSystem Runtime call using PSCI hvc calls
+
+  Copyright (c) 2014, Linaro Ltd. All rights reserved.<BR>
+
+  This program and the accompanying materials
+  are licensed and made available under the terms and conditions of the BSD License
+  which accompanies this distribution.  The full text of the license may be found at
+  http://opensource.org/licenses/bsd-license.php
+
+  THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS,
+  WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.
+
+**/
+
+#include <AsmMacroIoLibV8.h>
+#include <Base.h>
+#include <Library/ArmLib.h>
+#include <AutoGen.h>
+
+#define PSCI_0_2_FN_BASE               0x84000000
+#define PSCI_0_2_FN(n)                 (PSCI_0_2_FN_BASE + (n))
+#define PSCI_0_2_FN_SYSTEM_OFF         PSCI_0_2_FN(8)
+#define PSCI_0_2_FN_SYSTEM_RESET       PSCI_0_2_FN(9)
+
+.text
+.align 2
+
+GCC_ASM_EXPORT(ArmPsciSystemOff)
+GCC_ASM_EXPORT(ArmPsciSystemReset)
+
+ASM_PFX(ArmPsciSystemOff):
+  ldr    w0, =PSCI_0_2_FN_SYSTEM_OFF
+  hvc    #0
+  ret
+
+ASM_PFX(ArmPsciSystemReset):
+  ldr    w0, =PSCI_0_2_FN_SYSTEM_RESET
+  hvc    #0
+  ret
diff --git a/ArmPlatformPkg/ArmVirtualizationPkg/Library/ResetSystemLib/ARM/ResetSystemPsci.S b/ArmPlatformPkg/ArmVirtualizationPkg/Library/ResetSystemLib/ARM/ResetSystemPsci.S
new file mode 100644
index 000000000000..9e126c6627a7
--- /dev/null
+++ b/ArmPlatformPkg/ArmVirtualizationPkg/Library/ResetSystemLib/ARM/ResetSystemPsci.S
@@ -0,0 +1,41 @@
+/** @file
+  Support ResetSystem Runtime call using PSCI hvc calls
+
+  Copyright (c) 2014, Linaro Ltd. All rights reserved.<BR>
+
+  This program and the accompanying materials
+  are licensed and made available under the terms and conditions of the BSD License
+  which accompanies this distribution.  The full text of the license may be found at
+  http://opensource.org/licenses/bsd-license.php
+
+  THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS,
+  WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.
+
+**/
+
+#include <AsmMacroIoLib.h>
+#include <Base.h>
+#include <Library/ArmLib.h>
+#include <AutoGen.h>
+
+#define PSCI_0_2_FN_BASE               0x84000000
+#define PSCI_0_2_FN(n)                 (PSCI_0_2_FN_BASE + (n))
+#define PSCI_0_2_FN_SYSTEM_OFF         PSCI_0_2_FN(8)
+#define PSCI_0_2_FN_SYSTEM_RESET       PSCI_0_2_FN(9)
+
+.text
+.align 2
+.arch_extension virt
+
+GCC_ASM_EXPORT(ArmPsciSystemOff)
+GCC_ASM_EXPORT(ArmPsciSystemReset)
+
+ASM_PFX(ArmPsciSystemOff):
+  ldr    r0, =PSCI_0_2_FN_SYSTEM_OFF
+  hvc    #0
+  bx     lr
+
+ASM_PFX(ArmPsciSystemReset):
+  ldr    r0, =PSCI_0_2_FN_SYSTEM_RESET
+  hvc    #0
+  bx     lr
diff --git a/ArmPlatformPkg/ArmVirtualizationPkg/Library/ResetSystemLib/ResetSystemLib.c b/ArmPlatformPkg/ArmVirtualizationPkg/Library/ResetSystemLib/ResetSystemLib.c
new file mode 100644
index 000000000000..a420591a8e9c
--- /dev/null
+++ b/ArmPlatformPkg/ArmVirtualizationPkg/Library/ResetSystemLib/ResetSystemLib.c
@@ -0,0 +1,97 @@
+/** @file
+  Support ResetSystem Runtime call using PSCI hvc calls
+
+  Copyright (c) 2008 - 2009, Apple Inc. All rights reserved.<BR>
+  Copyright (c) 2013, ARM Ltd. All rights reserved.<BR>
+  Copyright (c) 2014, Linaro Ltd. All rights reserved.<BR>
+
+  This program and the accompanying materials
+  are licensed and made available under the terms and conditions of the BSD License
+  which accompanies this distribution.  The full text of the license may be found at
+  http://opensource.org/licenses/bsd-license.php
+
+  THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS,
+  WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.
+
+**/
+
+#include <PiDxe.h>
+
+#include <Library/BaseLib.h>
+#include <Library/DebugLib.h>
+#include <Library/EfiResetSystemLib.h>
+
+VOID
+ArmPsciSystemReset (
+  VOID
+  );
+
+VOID
+ArmPsciSystemOff (
+  VOID
+  );
+
+/**
+  Resets the entire platform.
+
+  @param  ResetType             The type of reset to perform.
+  @param  ResetStatus           The status code for the reset.
+  @param  DataSize              The size, in bytes, of WatchdogData.
+  @param  ResetData             For a ResetType of EfiResetCold, EfiResetWarm, or
+                                EfiResetShutdown the data buffer starts with a Null-terminated
+                                Unicode string, optionally followed by additional binary data.
+
+**/
+EFI_STATUS
+EFIAPI
+LibResetSystem (
+  IN EFI_RESET_TYPE   ResetType,
+  IN EFI_STATUS       ResetStatus,
+  IN UINTN            DataSize,
+  IN CHAR16           *ResetData OPTIONAL
+  )
+{
+  switch (ResetType) {
+
+  case EfiResetPlatformSpecific:
+    // Map the platform specific reset as reboot
+  case EfiResetWarm:
+    // Map a warm reset into a cold reset
+  case EfiResetCold:
+    // Send a PSCI 0.2 SYSTEM_RESET command
+    ArmPsciSystemReset ();
+    break;
+  case EfiResetShutdown:
+    // Send a PSCI 0.2 SYSTEM_OFF command
+    ArmPsciSystemOff ();
+    break;
+
+  default:
+    ASSERT (FALSE);
+    return EFI_UNSUPPORTED;
+  }
+
+  // We should never be here
+  DEBUG ((EFI_D_ERROR, "%a: PSCI Reset failed\n", __FUNCTION__));
+  CpuDeadLoop ();
+  return EFI_UNSUPPORTED;
+}
+
+/**
+  Initialize any infrastructure required for LibResetSystem () to function.
+
+  @param  ImageHandle   The firmware allocated handle for the EFI image.
+  @param  SystemTable   A pointer to the EFI System Table.
+  
+  @retval EFI_SUCCESS   The constructor always returns EFI_SUCCESS.
+
+**/
+EFI_STATUS
+EFIAPI
+LibInitializeResetSystem (
+  IN EFI_HANDLE        ImageHandle,
+  IN EFI_SYSTEM_TABLE  *SystemTable
+  )
+{
+  return EFI_SUCCESS;
+}
diff --git a/ArmPlatformPkg/ArmVirtualizationPkg/Library/ResetSystemLib/ResetSystemLib.inf b/ArmPlatformPkg/ArmVirtualizationPkg/Library/ResetSystemLib/ResetSystemLib.inf
new file mode 100644
index 000000000000..e50c134620b7
--- /dev/null
+++ b/ArmPlatformPkg/ArmVirtualizationPkg/Library/ResetSystemLib/ResetSystemLib.inf
@@ -0,0 +1,41 @@
+#/** @file
+# Reset System lib to make it easy to port new platforms
+#
+# Copyright (c) 2008, Apple Inc. All rights reserved.<BR>
+#
+#  This program and the accompanying materials
+#  are licensed and made available under the terms and conditions of the BSD License
+#  which accompanies this distribution. The full text of the license may be found at
+#  http://opensource.org/licenses/bsd-license.php
+#  THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS,
+#  WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.
+#
+#
+#**/
+
+[Defines]
+  INF_VERSION                    = 0x00010005
+  BASE_NAME                      = ResetSystemLib
+  FILE_GUID                      = DC9CCFDD-2638-474B-8F5D-031B758C12FC
+  MODULE_TYPE                    = BASE
+  VERSION_STRING                 = 1.0
+  LIBRARY_CLASS                  = EfiResetSystemLib
+
+[Sources.common]
+  ResetSystemLib.c
+
+[Sources.AARCH64]
+  AARCH64/ResetSystemPsci.S | GCC
+
+[Sources.ARM]
+  ARM/ResetSystemPsci.S     | GCC
+
+[Packages]
+  ArmPkg/ArmPkg.dec
+  MdePkg/MdePkg.dec
+  EmbeddedPkg/EmbeddedPkg.dec
+
+[LibraryClasses]
+  IoLib
+  DebugLib
+  BaseLib